unit crypt2;

interface
            function crypt(s:string):string;


implementation

uses
 atk_i_1;

var
  con1,con2,con3,con4:integer;


procedure fix;
asm
PUSH EBX
PUSH ESI
PUSH EDI
MOV EBX,EDX
MOV ECX,EBX
MOV ESI,EAX
MOV EDI,ESI
SHL EDI,CL
MOV ECX,$20
SUB ECX,EBX
SHR ESI,CL
OR EDI,ESI
MOV EAX,EDI
POP EDI
POP ESI
POP EBX
end;

procedure smallstep_3;
asm
XOR EAX,EDX
XOR EAX,ECX
end;

procedure smallstep_4;
asm
NOT ECX
OR ECX,EAX
XOR ECX,EDX
MOV EAX,ECX
end;

procedure smallstep_2;
asm
AND EAX,ECX
NOT ECX
AND ECX,EDX
OR EAX,ECX
end;

procedure smallstep_1;
asm
PUSH EBX
MOV EBX,EAX
AND EBX,EDX
NOT EAX
AND EAX,ECX
OR EBX,EAX
MOV EAX,EBX
POP EBX
end;

procedure step2;
asm
MOV EDI,ECX
MOV ESI,EDX
MOV EBX,EAX
MOV ECX,dword ptr [ESP+$10]
MOV EDX,EDI
MOV EAX,ESI
CALL smallstep_2
ADD EAX,[ebx]
ADD EAX,dword ptr [ESP+$C]
ADD EAX,DWORD PTR SS:[ESP+$4]
MOV [ebx],EAX
MOV EDX,DWORD PTR SS:[ESP+$8]
CALL fix
MOV DWORD PTR [EBX],EAX
ADD DWORD PTR [EBX],ESI
ret $10
end;

procedure step3;
asm
MOV EDI,ECX
MOV ESI,EDX
MOV EBX,EAX
MOV ECX,dword ptr [ESP+$10]
MOV EDX,EDI
MOV EAX,ESI
CALL smallstep_3
ADD EAX,[ebx]
ADD EAX,dword ptr [ESP+$C]
ADD EAX,DWORD PTR SS:[ESP+$4]
MOV [ebx],EAX
MOV EDX,DWORD PTR SS:[ESP+$8]
CALL fix
MOV DWORD PTR [EBX],EAX
ADD DWORD PTR [EBX],ESI
ret $10
end;

procedure step4;
asm
MOV EDI,ECX
MOV ESI,EDX
MOV EBX,EAX
MOV ECX,dword ptr [ESP+$10]
MOV EDX,EDI
MOV EAX,ESI
CALL smallstep_4
ADD EAX,[ebx]
ADD EAX,dword ptr [ESP+$C]
ADD EAX,DWORD PTR SS:[ESP+$4]
MOV [ebx],EAX
MOV EDX,DWORD PTR SS:[ESP+$8]
CALL fix
MOV DWORD PTR [EBX],EAX
ADD DWORD PTR [EBX],ESI
ret $10
end;

procedure step1;
asm
MOV EDI,ECX
MOV ESI,EDX
MOV EBX,EAX
MOV ECX,dword ptr [ESP+$10]
MOV EDX,EDI
MOV EAX,ESI
CALL smallstep_1
ADD EAX,[ebx]
ADD EAX,dword ptr [ESP+$C]
ADD EAX,DWORD PTR SS:[ESP+$4]
MOV [ebx],EAX
MOV EDX,DWORD PTR SS:[ESP+$8]
CALL fix
MOV DWORD PTR [EBX],EAX
ADD DWORD PTR [EBX],ESI
ret $10
end;

function rez (in_c:integer):string;
var
//i:integer;
s:string;
begin
result:='';
s:=inttohex(in_c,8);
result:=copy(s,7,2)+copy(s,5,2)+copy(s,3,2)+copy(s,1,2);
end;


function crypt(s:string):string;
var
//stek:string;
d:string[$40];
i:integer;
//con:array[1..4] of integer;
begin
con1:=$67452301;
con2:=$EFCDAB89;
con3:=$98BADCFE;
con4:=$10325476;
fillchar(d,$40,0);
d:=s+#$80;
i:=length(d)-1;
asm
pushad
lea edx, d
add edx,1
push edx
mov ecx,edx
mov edx,i
shl edx,3
mov [ecx+$38], edx

MOV ECX,$40

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax]
PUSH EAX                                 // |Arg3
PUSH $7                                  // |Arg2 = 00000007
PUSH $D76AA478                           // |Arg1 = D76AA478
lea EAX,con1                              // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step1

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$4]
PUSH EAX                                 // |Arg3
PUSH $0C                                 // |Arg2 = 0000000C
PUSH $E8C7B756                           // |Arg1 = E8C7B756
lea EAX,con4                              // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step1                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$8]
PUSH EAX                                 // |Arg3
PUSH $11                                 // |Arg2 = 0000000C
PUSH $242070DB                           // |Arg1 = E8C7B756
lea EAX,con3                              // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step1                               // \ATKInfo.004609F0


MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$C]
PUSH EAX                                 // |Arg3
PUSH $16                                 // |Arg2 = 0000000C
PUSH $C1BDCEEE                           // |Arg1 = E8C7B756
lea EAX,con2                              // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step1                               // \ATKInfo.004609F0


MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$10]
PUSH EAX                                 // |Arg3
PUSH $7                                  // |Arg2 = 0000000C
PUSH $F57C0FAF                           // |Arg1 = E8C7B756
lea EAX,con1                              // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step1                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$14]
PUSH EAX                                 // |Arg3
PUSH $0C                                  // |Arg2 = 0000000C
PUSH $4787C62A                           // |Arg1 = E8C7B756
lea EAX,con4                              // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step1                               // \ATKInfo.004609F0


MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$18]
PUSH EAX                                 // |Arg3
PUSH $11                                 // |Arg2 = 0000000C
PUSH $A8304613                           // |Arg1 = E8C7B756
lea EAX,con3                              // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step1                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$1C]
PUSH EAX                                 // |Arg3
PUSH $16                                 // |Arg2 = 0000000C
PUSH $FD469501                           // |Arg1 = E8C7B756
lea EAX,con2                              // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step1                               // \ATKInfo.004609F0

///////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$20]
PUSH EAX                                 // |Arg3
PUSH $7                                  // |Arg2 = 0000000C
PUSH $698098D8                           // |Arg1 = E8C7B756
lea EAX,con1                              // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step1                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$24]
PUSH EAX                                 // |Arg3
PUSH $0C                                  // |Arg2 = 0000000C
PUSH $8B44F7AF                           // |Arg1 = E8C7B756
lea EAX,con4                              // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step1                               // \ATKInfo.004609F0


MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$28]
PUSH EAX                                 // |Arg3
PUSH $11                                 // |Arg2 = 0000000C
PUSH $FFFF5BB1                           // |Arg1 = E8C7B756
lea EAX,con3                              // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step1                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$2C]
PUSH EAX                                 // |Arg3
PUSH $16                                 // |Arg2 = 0000000C
PUSH $895CD7BE                           // |Arg1 = E8C7B756
lea EAX,con2                              // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step1                               // \ATKInfo.004609F0
/////////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$30]
PUSH EAX                                 // |Arg3
PUSH $7                                  // |Arg2 = 0000000C
PUSH $6B901122                           // |Arg1 = E8C7B756
lea EAX,con1                              // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step1                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$34]
PUSH EAX                                 // |Arg3
PUSH $0C                                  // |Arg2 = 0000000C
PUSH $FD987193                           // |Arg1 = E8C7B756
lea EAX,con4                              // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step1                               // \ATKInfo.004609F0


MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$38]
PUSH EAX                                 // |Arg3
PUSH $11                                 // |Arg2 = 0000000C
PUSH $A679438E                           // |Arg1 = E8C7B756
lea EAX,con3                              // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step1                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$3C]
PUSH EAX                                 // |Arg3
PUSH $16                                 // |Arg2 = 0000000C
PUSH $49B40821                           // |Arg1 = E8C7B756
lea EAX,con2                              // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step1                               // \ATKInfo.004609F0

///////////////////////////////////////////////////////
///////      28                       ///////
///////////////////////////////////////////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$4]
PUSH EAX                                 // |Arg3
PUSH $5                                  // |Arg2 = 0000000C
PUSH $F61E2562                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step2                               // \ATKInfo.004609F0


MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$18]
PUSH EAX                                 // |Arg3
PUSH $9                                  // |Arg2 = 0000000C
PUSH $C040B340                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step2                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$2C]
PUSH EAX                                 // |Arg3
PUSH $0E                                 // |Arg2 = 0000000C
PUSH $265E5A51                           // |Arg1 = 265E5A51
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step2                               // \ATKInfo.004609F0


MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax]
PUSH EAX                                 // |Arg3
PUSH $14                                 // |Arg2 = 0000000C
PUSH $E9B6C7AA                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step2                               // \ATKInfo.004609F0

//////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$14]
PUSH EAX                                 // |Arg3
PUSH $5                                  // |Arg2 = 0000000C
PUSH $D62F105D                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step2                               // \ATKInfo.004609F0


MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$28]
PUSH EAX                                 // |Arg3
PUSH $9                                  // |Arg2 = 0000000C
PUSH $2441453                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step2                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$3C]
PUSH EAX                                 // |Arg3
PUSH $0E                                 // |Arg2 = 0000000C
PUSH $D8A1E681                           // |Arg1 = 265E5A51
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step2                               // \ATKInfo.004609F0


MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$10]
PUSH EAX                                 // |Arg3
PUSH $14                                 // |Arg2 = 0000000C
PUSH $E7D3FBC8                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step2                               // \ATKInfo.004609F0

///////////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$24]
PUSH EAX                                 // |Arg3
PUSH $5                                  // |Arg2 = 0000000C
PUSH $21E1CDE6                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step2                               // \ATKInfo.004609F0


MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$38]
PUSH EAX                                 // |Arg3
PUSH $9                                  // |Arg2 = 0000000C
PUSH $C33707D6                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step2                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$C]
PUSH EAX                                 // |Arg3
PUSH $0E                                 // |Arg2 = 0000000C
PUSH $F4D50D87                           // |Arg1 = 265E5A51
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step2                               // \ATKInfo.004609F0


MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$20]
PUSH EAX                                 // |Arg3
PUSH $14                                 // |Arg2 = 0000000C
PUSH $455A14ED                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step2                               // \ATKInfo.004609F0

///////////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$34]
PUSH EAX                                 // |Arg3
PUSH $5                                  // |Arg2 = 0000000C
PUSH $A9E3E905                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step2                               // \ATKInfo.004609F0


MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$8]
PUSH EAX                                 // |Arg3
PUSH $9                                  // |Arg2 = 0000000C
PUSH $FCEFA3F8                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step2                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$1C]
PUSH EAX                                 // |Arg3
PUSH $0E                                 // |Arg2 = 0000000C
PUSH $676F02D9                           // |Arg1 = 265E5A51
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step2                               // \ATKInfo.004609F0


MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$30]
PUSH EAX                                 // |Arg3
PUSH $14                                 // |Arg2 = 0000000C
PUSH $8D2A4C8A                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step2                               // \ATKInfo.004609F0


///////////////////////////////////////////////////////
///////      60                       ///////
///////////////////////////////////////////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$14]
PUSH EAX                                 // |Arg3
PUSH $4                                  // |Arg2 = 0000000C
PUSH $FFFA3942                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$20]
PUSH EAX                                 // |Arg3
PUSH $0B                                 // |Arg2 = 0000000C
PUSH $8771F681                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$2C]
PUSH EAX                                 // |Arg3
PUSH $10                                 // |Arg2 = 0000000C
PUSH $6D9D6122                           // |Arg1 = E8C7B756
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$38]
PUSH EAX                                 // |Arg3
PUSH $17                                 // |Arg2 = 0000000C
PUSH $FDE5380C                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step3                               // \ATKInfo.004609F0

///////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$4]
PUSH EAX                                 // |Arg3
PUSH $4                                  // |Arg2 = 0000000C
PUSH $A4BEEA44                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$10]
PUSH EAX                                 // |Arg3
PUSH $0B                                 // |Arg2 = 0000000C
PUSH $4BDECFA9                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$1C]
PUSH EAX                                 // |Arg3
PUSH $10                                 // |Arg2 = 0000000C
PUSH $F6BB4B60                           // |Arg1 = E8C7B756
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$28]
PUSH EAX                                 // |Arg3
PUSH $17                                 // |Arg2 = 0000000C
PUSH $BEBFBC70                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step3                               // \ATKInfo.004609F0

///////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$34]
PUSH EAX                                 // |Arg3
PUSH $4                                  // |Arg2 = 0000000C
PUSH $289B7EC6                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax]
PUSH EAX                                 // |Arg3
PUSH $0B                                 // |Arg2 = 0000000C
PUSH $EAA127FA                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$C]
PUSH EAX                                 // |Arg3
PUSH $10                                 // |Arg2 = 0000000C
PUSH $D4EF3085                           // |Arg1 = E8C7B756
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$18]
PUSH EAX                                 // |Arg3
PUSH $17                                 // |Arg2 = 0000000C
PUSH $4881D05                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step3                               // \ATKInfo.004609F0

////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$24]
PUSH EAX                                 // |Arg3
PUSH $4                                  // |Arg2 = 0000000C
PUSH $D9D4D039                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$30]
PUSH EAX                                 // |Arg3
PUSH $0B                                 // |Arg2 = 0000000C
PUSH $E6DB99E5                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$3C]
PUSH EAX                                 // |Arg3
PUSH $10                                 // |Arg2 = 0000000C
PUSH $1FA27CF8                           // |Arg1 = E8C7B756
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step3                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$8]
PUSH EAX                                 // |Arg3
PUSH $17                                 // |Arg2 = 0000000C
PUSH $C4AC5665                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step3                               // \ATKInfo.004609F0

///////////////////////////////////////////////////////
///////      98                       ///////
///////////////////////////////////////////////////////
MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax]
PUSH EAX                                 // |Arg3
PUSH $6                                  // |Arg2 = 0000000C
PUSH $F4292244                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$1C]
PUSH EAX                                 // |Arg3
PUSH $0A                                 // |Arg2 = 0000000C
PUSH $432AFF97                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$38]
PUSH EAX                                 // |Arg3
PUSH $0F                                 // |Arg2 = 0000000C
PUSH $AB9423A7                           // |Arg1 = E8C7B756
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$14]
PUSH EAX                                 // |Arg3
PUSH $15                                 // |Arg2 = 0000000C
PUSH $FC93A039                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step4                               // \ATKInfo.004609F0

/////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$30]
PUSH EAX                                 // |Arg3
PUSH $6                                  // |Arg2 = 0000000C
PUSH $655B59C3                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$C]
PUSH EAX                                 // |Arg3
PUSH $0A                                 // |Arg2 = 0000000C
PUSH $8F0CCC92                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$28]
PUSH EAX                                 // |Arg3
PUSH $0F                                 // |Arg2 = 0000000C
PUSH $FFEFF47D                           // |Arg1 = E8C7B756
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$4]
PUSH EAX                                 // |Arg3
PUSH $15                                 // |Arg2 = 0000000C
PUSH $85845DD1                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step4                               // \ATKInfo.004609F0

/////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$20]
PUSH EAX                                 // |Arg3
PUSH $6                                  // |Arg2 = 0000000C
PUSH $6FA87E4F                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$3C]
PUSH EAX                                 // |Arg3
PUSH $0A                                 // |Arg2 = 0000000C
PUSH $FE2CE6E0                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$18]
PUSH EAX                                 // |Arg3
PUSH $0F                                 // |Arg2 = 0000000C
PUSH $A3014314                           // |Arg1 = E8C7B756
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$34]
PUSH EAX                                 // |Arg3
PUSH $15                                 // |Arg2 = 0000000C
PUSH $4E0811A1                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step4                               // \ATKInfo.004609F0

/////////////////

MOV EAX,con4
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$10]
PUSH EAX                                 // |Arg3
PUSH $6                                  // |Arg2 = 0000000C
PUSH $F7537E82                           // |Arg1 = E8C7B756
lea EAX,con1                             // |
MOV ECX,con3                             // |
MOV EDX,con2                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con3
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$2C]
PUSH EAX                                 // |Arg3
PUSH $0A                                 // |Arg2 = 0000000C
PUSH $BD3AF235                           // |Arg1 = E8C7B756
lea EAX,con4                             // |
MOV ECX,con2                             // |
MOV EDX,con1                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con2
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$8]
PUSH EAX                                 // |Arg3
PUSH $0F                                 // |Arg2 = 0000000C
PUSH $2AD7D2BB                           // |Arg1 = E8C7B756
lea EAX,con3                             // |
MOV ECX,con1                             // |
MOV EDX,con4                             // |
CALL step4                               // \ATKInfo.004609F0

MOV EAX,con1
PUSH EAX                                 // /Arg4
mov eax,[esp+$4]
mov eax, [eax+$24]
PUSH EAX                                 // |Arg3
PUSH $15                                 // |Arg2 = 0000000C
PUSH $EB86D391                           // |Arg1 = E8C7B756
lea EAX,con2                             // |
MOV ECX,con4                             // |
MOV EDX,con3                             // |
CALL step4                               // \ATKInfo.004609F0

/////////////////

mov eax,$67452301
mov ebx,$EFCDAB89
mov ecx,$98BADCFE
mov edx,$10325476
ADD con1,eax
ADD con2,ebx
ADD con3,ecx
ADD con4,edx
pop edx
popad
end;

result:=rez(con1)+rez(con2)+rez(con3)+rez(con4);

end;

end.

